SubstringMatcher (JUnit API)
Date: 2016-08-24

org.hamcrest.core

## Class SubstringMatcher

- java.lang.Object
- - org.hamcrest.BaseMatcher<T>
  - - org.hamcrest.TypeSafeMatcher<String>
    - - org.hamcrest.core.SubstringMatcher

- All Implemented Interfaces:
    Matcher<String>, SelfDescribing
  Direct Known Subclasses:
    StringContains, StringEndsWith, StringStartsWith

      public abstract class SubstringMatcher
      extends TypeSafeMatcher<String>

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected String` | `substring`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `SubstringMatcher(String substring)`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `describeMismatchSafely(String item, Description mismatchDescription)` Subclasses should override this.
    `void` | `describeTo(Description description)` Generates a description of the object.
    `protected abstract boolean` | `evalSubstringOf(String string)`
    `boolean` | `matchesSafely(String item)` Subclasses should implement this.
    `protected abstract String` | `relationship()`

    - ### Methods inherited from class org.hamcrest.TypeSafeMatcher

      `describeMismatch, matches`

    - ### Methods inherited from class org.hamcrest.BaseMatcher

      `_dont_implement_Matcher___instead_extend_BaseMatcher_, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### substring

          protected final String substring

  - ### Constructor Detail

    - #### SubstringMatcher

          protected SubstringMatcher(String substring)

  - ### Method Detail

    - #### matchesSafely

          public boolean matchesSafely(String item)

      Description copied from class: `TypeSafeMatcher`
      Subclasses should implement this. The item will already have been checked for the specific type and will never be null.
      Specified by:
        `matchesSafely` in class `TypeSafeMatcher<String>`

    - #### describeMismatchSafely

          public void describeMismatchSafely(String item,
                                             Description mismatchDescription)

      Description copied from class: `TypeSafeMatcher`
      Subclasses should override this. The item will already have been checked for the specific type and will never be null.
      Overrides:
        `describeMismatchSafely` in class `TypeSafeMatcher<String>`

    - #### describeTo

          public void describeTo(Description description)

      Description copied from interface: `SelfDescribing`
      Generates a description of the object. The description may be part of a a description of a larger object of which this is just a component, so it should be worded appropriately.
      Parameters:
        `description` - The description to be built or appended to.

    - #### evalSubstringOf

          protected abstract boolean evalSubstringOf(String string)

    - #### relationship

          protected abstract String relationship()